#include <Xm/Xm.h>
#include <Xm/XmStrDefs.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <varargs.h>

#include "xmps.h"


void regerror (errorCondition)
     String errorCondition;
{
     extern void error ();
     error ("Malformed regular expression :\n%s",
	    errorCondition, (char *) 0);
}


void error (va_alist)
     va_dcl
{
     static Widget errorDialog = NULL;

     va_list args;
     char *format;
     char s[512];
     XmString message;
     
     Arg arglist[2];
     Cardinal i;

     if (! errorDialog) {
	  XmString title;
	  
	  title = XmStringCreateLtoR ("Error Dialog",
				      XmSTRING_DEFAULT_CHARSET);
     
	  i = 0;
	  XtSetArg (arglist[i], XmNdialogTitle,  title); i++;
	  XtSetArg (arglist[i], XmNdialogStyle, XmDIALOG_MODELESS); i++;
	  errorDialog = (Widget) XmCreateErrorDialog (topLevel, "errorDialog",
						      arglist, i);

	  XtUnmanageChild ((Widget) XmMessageBoxGetChild (errorDialog,
							  XmDIALOG_CANCEL_BUTTON));
	  XtUnmanageChild ((Widget) XmMessageBoxGetChild (errorDialog,
							  XmDIALOG_HELP_BUTTON));

	  XmStringFree (title);
     }

     /*
      * Format the message.
      */
     va_start (args);
     
     format = (char *) va_arg (args, char *);
     vsprintf (s, format, args);

     va_end (args);
     
     /*
      * Display it.
      */
     message = XmStringCreateLtoR (s, XmSTRING_DEFAULT_CHARSET);

     i = 0;
     XtSetArg (arglist[i], XmNmessageString, message); i++;
     XtSetValues (errorDialog, arglist, i);

     XmStringFree (message);

     XtManageChild (errorDialog);
}
