XrmOptionDescRec xmPsOptions[] = {
     { "-hosts", "*hosts", XrmoptionSepArg, (caddr_t) "localhost" },
     { "-actions", "*actions", XrmoptionSepArg, (caddr_t) "kill" },
     { "-users", "*users", XrmoptionSepArg, (caddr_t) "all" },
     { "-groups", "*groups", XrmoptionSepArg, (caddr_t) "all" },
     { "-terminals", "*terminals", XrmoptionSepArg, (caddr_t) "" },
     { "-ps", "*psCommand", XrmoptionSepArg, (caddr_t) "/bin/ps" },
     { "-pspp", "*beautifyCommand", XrmoptionSepArg, (caddr_t) "" },
     { "-rsh", "*rshCommand", XrmoptionSepArg, (caddr_t) "remsh" },
};

XtResource xmPsResources[] = {
     { "hosts", "Hosts", XtRString,
	  sizeof (String), XtOffset (ResourceRec, hosts),
          XtRString, (caddr_t) "localhost" },
     { "actions", "Actions", XtRString,
	  sizeof (String), XtOffset (ResourceRec, actions),
          XtRString, (caddr_t) "kill" },

     { "users", "Users", XtRString,
	  sizeof (String), XtOffset (ResourceRec, users),
          XtRString, (caddr_t) "all" },
     { "usersOption", "UsersOption", XtRString,
	  sizeof (String), XtOffset (ResourceRec, usersOption),
          XtRString, (caddr_t) "u" },
     { "groups", "groups", XtRString,
	  sizeof (String), XtOffset (ResourceRec, groups),
          XtRString, (caddr_t) "all" },
     { "groupsOption", "GroupsOption", XtRString,
	  sizeof (String), XtOffset (ResourceRec, groupsOption),
          XtRString, (caddr_t) "g" },
     { "terminals", "terminals", XtRString,
	  sizeof (String), XtOffset (ResourceRec, terminals),
          XtRString, (caddr_t) "" },
     { "terminalsOption", "TerminalsOption", XtRString,
	  sizeof (String), XtOffset (ResourceRec, terminalsOption),
          XtRString, (caddr_t) "t" },

     { "psCommand", "PsCommand", XtRString,
	  sizeof (String), XtOffset (ResourceRec, psCommand),
          XtRString, (caddr_t) "/bin/ps" },
     { "rshCommand", "RshCommand", XtRString,
	  sizeof (String), XtOffset (ResourceRec, rshCommand),
          XtRString, (caddr_t) "remsh" },
     { "printCommand", "PrintCommand", XtRString,
	  sizeof (String), XtOffset (ResourceRec, printCommand),
          XtRString, (caddr_t) "lp %s" },
     { "beautifyCommand", "BeautifyCommand", XtRString,
	  sizeof (String), XtOffset (ResourceRec, beautifyCommand),
          XtRString, (caddr_t) "" },

     { "refreshPeriod", "RefreshPeriod", XtRInt,
	  sizeof (int), XtOffset (ResourceRec, refreshPeriod),
          XtRString, (caddr_t) "600" },

     { "automaticRefresh", "AutomaticRefresh", XtRBoolean,
	  sizeof (Boolean), XtOffset (ResourceRec, automaticRefresh),
          XtRString, (caddr_t) "True" },
     { "periodicRefresh", "PeriodicRefresh", XtRBoolean,
	  sizeof (Boolean), XtOffset (ResourceRec, periodicRefresh),
          XtRString, (caddr_t) "False" },
     { "automaticMemory", "AutomaticMemory", XtRBoolean,
	  sizeof (Boolean), XtOffset (ResourceRec, automaticMemory),
          XtRString, (caddr_t) "True" },
     { "beautify", "Beautify", XtRBoolean,
	  sizeof (Boolean), XtOffset (ResourceRec, beautify),
          XtRString, (caddr_t) "True" },
     { "multipleOccurrences", "MultipleOccurrences", XtRBoolean,
	  sizeof (Boolean), XtOffset (ResourceRec, multipleOccurrences),
          XtRString, (caddr_t) "False" },
     { "ignoreCase", "IgnoreCase", XtRBoolean,
	  sizeof (Boolean), XtOffset (ResourceRec, ignoreCase),
          XtRString, (caddr_t) "True" },
     { "printSelected", "PrintSelected", XtRBoolean,
	  sizeof (Boolean), XtOffset (ResourceRec, printSelected),
          XtRString, (caddr_t) "False" },

     { "allProcesses", "AllProcesses", XtRBoolean,
	  sizeof (Boolean), XtOffset (ResourceRec, allProcesses),
          XtRString, (caddr_t) "True" },
     { "noGroupLeader", "NoGroupLeader", XtRBoolean,
	  sizeof (Boolean), XtOffset (ResourceRec, noGroupLeader),
          XtRString, (caddr_t) "False" },
     { "noNonTerminal", "NoNonTerminal", XtRBoolean,
	  sizeof (Boolean), XtOffset (ResourceRec, noNonTerminal),
          XtRString, (caddr_t) "False" },

     { "allProcessesOption", "AllProcessesOption", XtRString,
	  sizeof (String), XtOffset (ResourceRec, allProcessesOption),
          XtRString, (caddr_t) "e" },
     { "noGroupLeaderOption", "NoGroupLeaderOption", XtRString,
	  sizeof (String), XtOffset (ResourceRec, noGroupLeaderOption),
          XtRString, (caddr_t) "d" },
     { "noNonTerminalOption", "NoNonTerminalOption", XtRString,
	  sizeof (String), XtOffset (ResourceRec, noNonTerminalOption),
          XtRString, (caddr_t) "a" },

     { "fullListing", "FullListing", XtRBoolean,
	  sizeof (Boolean), XtOffset (ResourceRec, fullListing),
          XtRString, (caddr_t) "True" },
     { "longListing", "LongListing", XtRBoolean,
	  sizeof (Boolean), XtOffset (ResourceRec, longListing),
          XtRString, (caddr_t) "False" },

     { "fullListingOption", "FullListingOption", XtRString,
	  sizeof (String), XtOffset (ResourceRec, fullListingOption),
          XtRString, (caddr_t) "f" },
     { "longListingOption", "LongListingOption", XtRString,
	  sizeof (String), XtOffset (ResourceRec, longListingOption),
          XtRString, (caddr_t) "l" },

     { "clusterWide", "ClusterWide", XtRBoolean,
	  sizeof (Boolean), XtOffset (ResourceRec, clusterWide),
          XtRString, (caddr_t) "False" },
     { "clusterWideOption", "ClusterWideOption", XtRString,
	  sizeof (String), XtOffset (ResourceRec, clusterWideOption),
          XtRString, (caddr_t) "c" },
};


