#include <Xm/Xm.h>
#include <Xm/XmStrDefs.h>
#include <Xm/Frame.h>
#include <Xm/MainW.h>
#include <Xm/List.h>
#include <Xm/PushBG.h>
#include <Xm/RowColumn.h>
#include <Xm/ScrolledW.h>
#include <Xm/SeparatoG.h>
#include <Xm/Text.h>
#include <Xm/ToggleBG.h>

#include <stdio.h>

#include "xmps.h"


int takeSnapshot (widget, clientData, callData)
     Widget widget;
     caddr_t clientData;
     caddr_t callData;
{
     extern void createSnapshot ();

     setBusyIndicator ();
     createSnapshot (topLevel);
     unsetBusyIndicator ();
}


void duplicateList (parent, status, header, list)
     Widget parent;
     Widget status;
     Widget header;
     Widget list;
{
     Widget snapshotTopWindow;
     Widget snapshotStatusArea;
     Widget snapshotSeparator;
     Widget snapshotHeaderArea;
     Widget snapshotProcessArea;
     
     XmFontList fontList;
     XmString label;
     XmStringTable items;
     int itemCount;
     int current;

     Arg arglist[10];
     Cardinal i;
     
     /*
      * Create a form.
      */
     i = 0;
     XtSetArg (arglist[i], XmNorientation, XmVERTICAL); i++;
     XtSetArg (arglist[i], XmNpacking, XmPACK_NONE); i++;
     snapshotTopWindow = (Widget) XmCreateForm (parent,
						"snapshotTopWindow",
						arglist, i);
     XtManageChild (snapshotTopWindow);

     /*
      * Add a status line.
      */
     i = 0;
     XtSetArg (arglist[i], XmNlabelString, &label); i++;
     XtSetArg (arglist[i], XmNfontList, &fontList); i++;
     XtGetValues (status, arglist, i);

     i = 0;
     XtSetArg (arglist[i], XmNlabelString, label); i++;
     XtSetArg (arglist[i], XmNfontList, fontList); i++;
     XtSetArg (arglist[i], XmNalignment, XmALIGNMENT_BEGINNING); i++;
     XtSetArg (arglist[i], XmNtopAttachment, XmATTACH_FORM); i++;
     XtSetArg (arglist[i], XmNleftAttachment, XmATTACH_FORM); i++;
     XtSetArg (arglist[i], XmNrightAttachment, XmATTACH_FORM); i++;
     XtSetArg (arglist[i], XmNbottomAttachment, XmATTACH_NONE); i++;
     snapshotStatusArea = (Widget) XmCreateLabelGadget (snapshotTopWindow,
							"snapshotStatusArea",
							arglist, i);
     XtManageChild (snapshotStatusArea);
     
     /*
      * Add a separator.
      */
     i = 0;
     XtSetArg (arglist[i], XmNtopAttachment, XmATTACH_WIDGET); i++;
     XtSetArg (arglist[i], XmNtopWidget, snapshotStatusArea); i++;
     XtSetArg (arglist[i], XmNleftAttachment, XmATTACH_FORM); i++;
     XtSetArg (arglist[i], XmNrightAttachment, XmATTACH_FORM); i++;
     XtSetArg (arglist[i], XmNbottomAttachment, XmATTACH_NONE); i++;
     snapshotSeparator = XmCreateSeparatorGadget (snapshotTopWindow,
						  "snapshotSeparator",
						  arglist, i);

     XtManageChild (snapshotSeparator);

     /*
      * Add a header.
      */
     i = 0;
     XtSetArg (arglist[i], XmNlabelString, &label); i++;
     XtSetArg (arglist[i], XmNfontList, &fontList); i++;
     XtGetValues (header, arglist, i);

     i = 0;
     XtSetArg (arglist[i], XmNlabelString, label); i++;
     XtSetArg (arglist[i], XmNfontList, fontList); i++;
     XtSetArg (arglist[i], XmNalignment, XmALIGNMENT_BEGINNING); i++;
     XtSetArg (arglist[i], XmNtopAttachment, XmATTACH_WIDGET); i++;
     XtSetArg (arglist[i], XmNtopWidget, snapshotSeparator); i++;
     XtSetArg (arglist[i], XmNleftAttachment, XmATTACH_FORM); i++;
     XtSetArg (arglist[i], XmNrightAttachment, XmATTACH_FORM); i++;
     XtSetArg (arglist[i], XmNbottomAttachment, XmATTACH_NONE); i++;
     snapshotHeaderArea = (Widget) XmCreateLabelGadget (snapshotTopWindow,
							"snapshotHeaderArea",
							arglist, i);
     XtManageChild (snapshotHeaderArea);
     
     /*
      * Add a scrolledList.
      */
     i = 0;
     XtSetArg (arglist[i], XmNfontList, &fontList); i++;
     XtSetArg (arglist[i], XmNitems, &items); i++;
     XtSetArg (arglist[i], XmNitemCount, &itemCount); i++;
     XtGetValues (list, arglist, i);

     i = 0;
     XtSetArg (arglist[i], XmNfontList, fontList); i++;

     XtSetArg (arglist[i], XmNlistSizePolicy, XmCONSTANT); i++;
     XtSetArg (arglist[i], XmNselectionPolicy, XmSINGLE_SELECT); i++;

     XtSetArg (arglist[i], XmNtopAttachment, XmATTACH_WIDGET); i++;
     XtSetArg (arglist[i], XmNtopWidget, snapshotHeaderArea); i++;
     XtSetArg (arglist[i], XmNleftAttachment, XmATTACH_FORM); i++;
     XtSetArg (arglist[i], XmNrightAttachment, XmATTACH_FORM); i++;
     XtSetArg (arglist[i], XmNbottomAttachment, XmATTACH_FORM); i++;

     snapshotProcessArea = XmCreateScrolledList (snapshotTopWindow, 
						 "snapshotProcessArea",
						 arglist, i);
     XtManageChild (snapshotProcessArea);

     /*
      * Add the items of the current list to the new list.
      */
     for (current = 0; current < itemCount; current++)
	  XmListAddItemUnselected (snapshotProcessArea, items[current], 0);
}


void createSnapshot (parent)
     Widget parent;
{
     Widget snapshotTopLevel;
     Widget statusArea = XtNameToWidget (topLevel,
					 "topWindow.selectionArea.statusArea");
     Dimension width, height;

     Arg arglist[3];
     Cardinal i;

     /*
      * Create a shell to have a separate window and interact directly with
      * the window manager.
      */
     i = 0;
     XtSetArg (arglist[i], XmNwidth, &width); i++;
     XtSetArg (arglist[i], XmNheight, &height); i++;
     XtGetValues (topLevel, arglist, i);

     i = 0;
     XtSetArg (arglist[i], XmNwidth, width); i++;
     XtSetArg (arglist[i], XmNheight, height); i++;
     snapshotTopLevel = XtCreatePopupShell ("Process Browser",
					    topLevelShellWidgetClass,
					    parent,
					    arglist, i);
     
     /*
      * Replicate the current window.
      */
     (void) duplicateList (snapshotTopLevel, statusArea, headerArea, listArea);
     
     /*
      * Display the new window.
      */
     XtRealizeWidget (snapshotTopLevel);
     XtMapWidget (snapshotTopLevel);
     XRaiseWindow (XtDisplay (snapshotTopLevel), XtWindow (snapshotTopLevel));
}


