.TH XmPs 1X
.ds ]W X11R5 Motif 1.2 (8/10/92)
.SH NAME
\fBxmps \(em A X/Motif Process Browser.\fP
.sp 1
.SH SYNOPSIS
.B xmps
[options]
.sp 1
.SH DESCRIPTION
The X/Motif Process Browser \fIxmps\fP provides process manipulation
funtionalities. It offers several useful features including process
sorting by ancestry, the ability to search for a process by name (using
regular expressions), to kill a process or group of processes, to restrict
the process information to specific users, groups or terminals, and to keep
multiple snapshots of the process information.
.P
\fIXmps\fP can display many main windows, each of which contains
the processes of a single computer (not implemented yet). A menu bar provides
process operations.
.P
A direct manipulation paradigm is used to perform operations on the
displayed processes. Selection and multiple selection activate a process
or a set of processes. This is primarily used to indicate the active
object(s) for menu operations.
.P
\fIXmps\fP is especially useful to manage multiple hosts on a network.
Once \fIremsh(1)\fP privileges have been enabled on those other hosts, it
is possible to view and manipulate their processes from within a single
\fIxmps\fP session.
.sp 1
.SH OPTIONS
.TP 8
.BI \-ps " process status command"
This option specifies an alternative \fIps(1)\fP command to use to obtain
process information.
.TP 8
.BI \-pspp " pretty-printer command"
This option specifies an alternative command to use to sort processes by
ancestry.
.TP 8
.BI \-rsh " remote shell command"
This option specifies an alternative \fIremsh(1)\fP command to use to
run \fIps(1)\fP on remote hosts.
.TP 8
.BI \-hosts " hostname,[hostname,...]"
This option allows users to specify alternative \fIhost names\fP from which
they will be able to get process information.
.TP 8
.BI \-users " user,[user,...]"
This option allows users to specify alternative \fIuser ids\fP or \fIuser
names\fP to which they will be able to restrict the process information.
.TP 8
.BI \-groups " group,[group,...]"
This option allows users to specify alternative \fIgroup ids\fP or \fIgroup
names\fP to which they will be able to restrict the process information.
.TP 8
.BI \-terminals " terminal,[terminal,...]"
This option allows users to specify alternative \fIterminal names\fP to which
they will be able to restrict the process information.
.TP 8
.BI \-actions " action,[action,...]"
This option allows users to specify \fIactions\fP that can be applied to
active processes. The current action will be applied iteratively on each
active process and will be given as input that particular process number.
.sp 1
.SH FEATURES
.IP "\fBSelecting a Process\fP"
Clicking on a process selects it and deselects any other selected process.
Dragging over a range of processes, or pressing <Shift> while clicking,
selects all processes between the process under the mouse and the process
on which the first click was made. This also deselects any other selected
processes outside that range.
.sp 1
Also, users can select and deselect discontiguous ranges of processes.
Pressing <Ctrl> while clicking on a process toggles its selection state but
does not deselect any other selected items. Pressing <Ctrl> and dragging
over a range of processes sets the selection state of all processes between
the process under the mouse and the process on which the first <Ctrl>-click
was made to the state of that process. This does not deselect any other
selected processes outside that range.
.sp 1
All selection operations available from the mouse are also available from
the keyboard. Refer to \fIXmList(3X)\fP for more details.
.IP "\fBExecuting an Action on a Process\fP"
Actions can be executed on selected processes. There is no restriction on
what an action can do. However, the state of a process as displayed by
\fIxmps\fP is not refreshed after the action has been successfully executed.
The user must \fBRefresh\fP the process information himself in order to
keep that information up-to-date.
.sp 1
Actions are selected via a menu. However, an input area is provided to type
in an action which is not available in a menu. See \fBProcess Filtering\fP
for more details.
.IP "\fBCreating Snapshots\fP"
Snapshots of the process information can be taken and displayed in separate
and independant windows. It allows the user to compare the evolution of
processes on a host over time, or to compare processes running on different
hosts. 
.IP "\fBProcess Filtering\fP"
Processes belong to many different hosts, users, groups and terminals. The
Process Browser's filtering mechanism provides the
means by which the user can selectively display sets of processes.  The
types of filtering available include: by host, by user, by group, by terminal
and by terminal capabilities.
.sp 1
A status area below the menu bar displays the current user, group, terminal,
host and action. It has the following format :
.BI user:group(terminal)@host  (action)
.sp 1
Other hosts, users, groups and terminals can be selected from menus.
However, an input area is provided to type in a host, user, group or
terminal which is not available on the corresponding menu. New values typed
in are automatically added to the corresponding menu if
\fBautomaticMemory\fP is true.
.sp 1
The input area is normally not displayed. To make it visible, mouse <Button1>
should be pressed over the status area.
.IP "\fBSetting Display Preferences\fP"
Both simple and detailed representations for process display are provided.
.IP "\fBFinding Processes\fP"
Processes can be searched for a particular string. Search strings can
include regular expressions (see \fIregexp(5)\fP). When processes
match the search criteria, they become the selected processes. Only the
first process found is normaly selected; however, all matching processes
can be selected at once if \fBmultipleOccurrences\fP is true.
.sp 1
.SH RESOURCES
The following resources can be used to taylor the initial appearance of
\fIXmps\fP:
.sp 2
.TS
center;
cB sss
lB lB lB lB
l l l l.
X/Motif Process Browser Appearance Resource Set
Name	Class	Type	Default
_
actions	Actions	String	"kill"
allProcesses	AllProcesses	Boolean	True
automaticMemory	AutomaticMemory	Boolean	True
automaticRefresh	AutomaticRefresh	Boolean	True
beautify	Beautify	Boolean	True
clusterWide	ClusterWide	Boolean	False
fullListing	FullListing	Boolean	True
groups	Groups	String	"all"
hosts	Hosts	String	"localhost"
ignoreCase	IgnoreCase	Boolean	True
longListing	LongListing	Boolean	False
multipleOccurrences	MultipleOccurrences	Boolean	False
noGroupLeader	NoGroupLeader	Boolean	False
noNonTerminal	NoNonTerminal	Boolean	False
periodicRefresh	PeriodicRefresh	Boolean	False
printSelected	PrintSelected	Boolean	False
refreshPeriod	RefreshPeriod	unsigned int	600
terminals	Terminals	String	""
users	Users	String	"all"
.TE
.sp 1
.IP "\fBactions\fP"
This resource specifies a list of actions that can be applied to active
processes. When the \fBExecute Action\fP command is selected, the current
action is applied iteratively on each active process, and is given as input
that particular process number. If no process is active, no action is
requested. (Note: \fIactions\fP is a list of comma separated actions).
.sp 1
.IP "\fBallProcesses\fP"
This resource specifies whether \fIxmps\fP displays information about all
processes or only about processes associated with the current terminal
(if any). Refer to \fIps(1)\fP for more details.
.sp 1
.IP "\fBautomaticMemory\fP"
This resource specifies whether \fIxmps\fP adds to the corresponding menu
the hosts, users, groups, terminals and actions that are typed in the input
zone, or does not memorize them. 
.sp 1
.IP "\fBautomaticRefresh\fP"
This resource specifies whether \fIxmps\fP refreshes the process information
when a new host, user, group, terminal or listing option is specified, or
waits until
an explicit \fBRefresh\fP command is executed. When \fBAutomaticRefresh\fP
is true, the process information is also refreshed upon deiconification.
.sp 1
.IP "\fBbeautify\fP"
This resource specifies whether \fIxmps\fP sorts processes by ancestry
before displaying them, or generates a raw listing as output by \fIps(1)\fP.
By default, \fIxmps\fP uses an internal formatter to sort processes. However,
an external formatter can used if \fBBeautifierCommand\fP is set
appropriately. 
.sp 1
.IP "\fBclusterWide\fP"
This resource specifies whether \fIxmps\fP generates a cluster wide listing, or
displays only processes from the selected host. Refer to \fIps(1)\fP for more
details (not implemented).
.sp 1
.IP "\fBfullListing\fP"
This resource specifies whether \fIxmps\fP generates a full listing, or
displays only a short listing. Refer to \fIps(1)\fP for more details.
.sp 1
.IP "\fBgroups\fP"
This resource specifies a list of groups to which the process
information can be restricted to. (Note: \fIgroups\fP is a list of comma
separated groups).
.sp 1
.IP "\fBhosts\fP"
This resource specifies a list of hosts from which process information can
be obtained and displayed. (Note: \fIhosts\fP is a list of comma
separated hosts).
.sp 1
.IP "\fBignoreCase\fP"
This resource specifies whether \fIxmps\fP ignores the case when searching
for a process, or takes it into account (see \fIregcomp(3)\fP).
.sp 1
.IP "\fBlongListing\fP"
This resource specifies whether \fIxmps\fP generates a long listing, or
displays only a short listing. Refer to \fIps(1)\fP for more details.
.sp 1
.IP "\fBmultipleOccurrences\fP"
This resource specifies whether \fIxmps\fP selects multiple processes
matching the string being searched, or only the first one. Search strings
may be specified as regular expressions (see \fIregexp(5)\fP).
.sp 1
.IP "\fBnoGroupLeader\fP"
This resource specifies whether \fIxmps\fP displays information about all
processes, except process group leaders, or about processes associated
with the current terminal (if any). Refer to \fIps(1)\fP for more details.
.sp 1
.IP "\fBnoNonTerminal\fP"
This resource specifies whether \fIxmps\fP displays information about all
processes, except process group leaders and processes not associated with
a terminal, or about processes associated with the current terminal (if any).
Refer to \fIps(1)\fP for more details.
.sp 1
.IP "\fBperiodicRefresh\fP"
When \fBperiodicRefresh\fP is true, \fIxmps\fP refreshes the process
information after \fBrefreshPeriod\fP seconds have ellapsed since the
last refresh.
.sp 1
.IP "\fBprintSelected\fP"
This resource specifies whether \fIxmps\fP prints information only about 
selected processes (if any), or about all processes.
.sp 1
.IP "\fBrefreshPeriod\fP"
This resource specifies a time in second after which the process information
is refreshed if \fBperiodicRefresh\fP is true.
.sp 1
.IP "\fBterminals\fP"
This resource specifies a list of terminals to which the process
information can be restricted to. (Note: \fIterminals\fP is a list of comma
separated terminals).
.sp 1
.IP "\fBusers\fP"
This resource specifies a list of users to whom the displayed process
information may be restricted to. (Note: \fIusers\fP is a list of comma
separated users).
.P
The following resources can be used to adapt \fIxmps\fP to a 
system for which it was not designed:
.sp 2
.TS
center;
cB sss
lB lB lB lB
l l l l.
X/Motif Process Browser System Dependant Resource Set
Name	Class	Type	Default
_
allProcessesOption	AllProcessesOption	String	"e"
beautifyCommand	BeautifyCommand	String	""
clusterWideOption	ClusterWideOption	String	"c"
fullListingOption	FullListingOption	String	"f"
longListingOption	LongListingOption	String	"l"
noGroupLeaderOption	NoGroupLeaderOption	String	"d"
noNonTerminalOption	NoNonTerminalOption	String	"a"
printCommand	PrintCommand	String	"lp %s"
psCommand	PsCommand	String	"/bin/ps"
rshCommand	RshCommand	String	"remsh"
terminalsOption	TerminalsOption	String	"g"
usersOption	UsersOption	String	"u"
.TE
.sp 1
.IP "\fBallProcessesOption\fP"
This resource specifies the \fIps(1)\fP option corresponding to
\fBallProcesses\fP.
.sp 1
.IP "\fBbeautifyCommand\fP"
This resource specifies an alternate command to beautify the process
information. If this resource is not set, an internal formatter is used.
.sp 1
.IP "\fBclusterWideOption\fP"
This resource specifies the \fIps(1)\fP option corresponding to
\fBclusterWide\fP.
.sp 1
.IP "\fBfullListingOption\fP"
This resource specifies the \fIps(1)\fP option corresponding to
\fBfullListing\fP.
.sp 1
.IP "\fBgroupsOption\fP"
This resource specifies the \fIps(1)\fP option corresponding to
\fBgroups\fP.
.sp 1
.IP "\fBlongListingOption\fP"
This resource specifies the \fIps(1)\fP option corresponding to
\fBlongListing\fP.
.sp 1
.IP "\fBnoGroupLeaderOption\fP"
This resource specifies the \fIps(1)\fP option corresponding to
\fBnoGroupLeader\fP.
.sp 1
.IP "\fBnoNonTerminalOption\fP"
This resource specifies the \fIps(1)\fP option corresponding to
\fBnoNonTerminal\fP.
.sp 1
.IP "\fBprintCommand\fP"
This resource specifies the command to use to print the process information.
.sp 1
.IP "\fBpsCommand\fP"
This resource specifies the command to use to obtain the process information.
.sp 1
.IP "\fBrshCommand\fP"
This resource specifies the command to use to run a given command on
a remote host.
.sp 1
.IP "\fBterminalsOption\fP"
This resource specifies the \fIps(1)\fP option corresponding to
\fBterminals\fP.
.sp 1
.IP "\fBusersOption\fP"
This resource specifies the \fIps(1)\fP option corresponding to
\fBusers\fP.
.sp 1
.SH BUGS
The code to select all or multiple processes does not work.
.sp 1
The \fBCluster Wide\fP and the \fBNew View\fP commands are not implemented.
.sp 1
.SH COPYRIGHT
Copyright 1991, 1992 Jean-Jacques Moreau.
.sp 1 
.SH AUTHOR
Jean-Jacques Moreau (jjm@hplb.hpl.hp.com).
.sp 1
.SH RELATED INFORMATION
\fBX(1)\fP, \fBps(1)\fP, \fBkill(1)\fP, \fBremsh(1)\fP,
\fBregexp(5)\fP, \fBXmList(3X)\fP, \fBezps(1X)\fP, \fBxps(1X)\fP,
\fBpspp(1)\fP.
