#include <Xm/Xm.h>
#include <Xm/XmStrDefs.h>
#include <Xm/RowColumn.h>
#include <Xm/Text.h>

#include <stdio.h>

#include "xmps.h"


void toggleSetState (widget, newState)
     Widget widget;
     Boolean newState;
{
     Arg arglist[2];
     Cardinal i;
     
     if (XmIsRowColumn (widget)) {
	  unsigned char widgetType;
	  
	  i = 0;
	  XtSetArg (arglist[i], XmNrowColumnType, &widgetType); i++;
	  XtGetValues (widget, arglist, i);

	  if (widgetType == XmMENU_OPTION)
	       widget = XmOptionButtonGadget (widget);
     }

     if (XmIsText (widget)) {
	  XmTextSetEditable (widget, newState);
	  if (newState == True)
	       XtMapWidget (widget);
	  else
	       XtUnmapWidget (widget);
     } else {
	  i = 0;
	  XtSetArg (arglist[i], XmNsensitive, newState); i++;
	  XtSetValues (widget, arglist, i);
     }
}


void enableUser ()
{
     toggleSetState
	  (XtNameToWidget (topLevel,
			   "topWindow.menuArea.userMenu"),
	   True);
}


void disableUser ()
{
     toggleSetState
	  (XtNameToWidget (topLevel,
			   "topWindow.menuArea.userMenu"),
	   False);
}


void enableGroup ()
{
     toggleSetState
	  (XtNameToWidget (topLevel,
			   "topWindow.menuArea.groupMenu"),
	   True);
}


void disableGroup ()
{
     toggleSetState
	  (XtNameToWidget (topLevel,
			   "topWindow.menuArea.groupMenu"),
	   False);
}


void enableTerminal ()
{
     toggleSetState
	  (XtNameToWidget (topLevel,
			   "topWindow.menuArea.terminalMenu"),
	   True);
}


void disableTerminal ()
{
     toggleSetState
	  (XtNameToWidget (topLevel,
			   "topWindow.menuArea.terminalMenu"),
	   False);
}


